import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { HjmQuestions, HjmQuestionsParam } from './model';

/**
 * 分页查询题目
 */
export async function pageHjmQuestions(params: HjmQuestionsParam) {
  const res = await request.get<ApiResult<PageResult<HjmQuestions>>>(
    '/hjm/hjm-questions/page',
    params
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询题目列表
 */
export async function listHjmQuestions(params?: HjmQuestionsParam) {
  const res = await request.get<ApiResult<HjmQuestions[]>>(
    '/hjm/hjm-questions',
    params
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加题目
 */
export async function addHjmQuestions(data: HjmQuestions) {
  const res = await request.post<ApiResult<unknown>>(
    '/hjm/hjm-questions',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改题目
 */
export async function updateHjmQuestions(data: HjmQuestions) {
  const res = await request.put<ApiResult<unknown>>(
    '/hjm/hjm-questions',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除题目
 */
export async function removeHjmQuestions(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/hjm/hjm-questions/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除题目
 */
export async function removeBatchHjmQuestions(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/hjm/hjm-questions/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询题目
 */
export async function getHjmQuestions(id: number) {
  const res = await request.get<ApiResult<HjmQuestions>>(
    '/hjm/hjm-questions/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
